# curly — Working solution to the Krul puzzle

This tool will run a small compiler which implements the language from the [Krul
puzzle](https://bobpolis.com/krul/). The sources also contain an older
implementation, to be found in the interpreter files. This could also be used as
a drop-in replacement for the compiler, by changing the appropriate line in
`main.cpp`.

> [!Note]
> Running `curly` without arguments, it will show the solution to the online puzzle. When run with file arguments, it will try to parse those files as Krul sources and run them.

## Building

Build using:

`make`,

but first install the dependencies:

- [libsclogging](https://git.bobpolis.com/bob/libsclogging)
- [libscterm](https://git.bobpolis.com/bob/libscterm)
- [libscrequest](https://git.bobpolis.com/bob/libscrequest)
- libcurl

## Install

`sudo make install`

or, on OpenBSD:

`doas gmake install`

## Run

`curly`

